import sys
import os
import time
import platform

def getGWAMARPathRun():
    print(sys.argv[0])
    curr_path = os.path.abspath(sys.argv[0])
    print(curr_path)
    curr_path = os.path.abspath(os.path.join(curr_path, ".."))
    tmp_path = curr_path
    gwamar_path = curr_path
    last_tmp_path = tmp_path
    it_count = 0
    while len(tmp_path) > 1 and it_count < 20:
        it_count += 1
        curr_dir = os.path.basename(tmp_path)
        curr_path = os.path.abspath(os.path.join(tmp_path, ".."))
        sys.stdout.flush()
        
        if curr_dir.startswith("GWAMAR"):
            gwamar_path = tmp_path + "/"
            break
        elif os.path.exists(curr_path + "/gwamar/"):
            gwamar_path = curr_path + "/gwamar/"
            break
        else:
            tmp_path = curr_path
        if last_tmp_path == tmp_path or it_count == 20:
            print("Cannot determine GWAMAR path")
            exit()
    return gwamar_path;

sys.path += ["src/", "../", "../../"]

from drsoft.utils.gwamar_params_utils import *
from drsoft.utils.gwamar_utils import logExecutionTime

run_path = os.path.abspath(os.curdir)
gwamar_path = getGWAMARPathRun()
os.chdir(gwamar_path)

if sys.version.startswith("3"):
    raw_input = input

def createCommandParams(attrs, parameters):
    new_cmd = ""
    for key in attrs:
        if key in parameters:
            new_cmd += " "+key+"="+parameters[key]
    return new_cmd

def prepare(parameters):
    os.chdir(os.path.abspath("src/drsoft/prepare/"))

    params = ["D", "REVORDER", "SCORES", "NSCORES", "TSCORES", "OW", "W", "GEN_BIN_PROFILES", "GWAMAR_DATASETS", "DATASET_DIR",  "MT", "EP"]
    passed_params = createCommandParams(params, parameters)

    t0_time = time.time()
    if os.system(python_cmd + " p0_save_strains_ordered.py" + passed_params): exit()
    if os.system(python_cmd + " p1_prepare_experiments.py" + passed_params): exit()
    if os.system(python_cmd + " p2_convert_profiles_genes.py" + passed_params): exit()
    if os.system(python_cmd + " p3_convert_profiles_muts.py" + passed_params): exit()
    if os.system(python_cmd + " p4_gen_binary_trees.py" + passed_params): exit()
    if os.system(python_cmd + " p5_cmp_resistance_profiles.py" + passed_params): exit()
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "profiles prepared")
    
def scores_std(parameters):
    os.chdir(os.path.abspath("src/drsoft/scoring/"))

    params = ["D", "REVORDER", "SCORES", "NSCORES", "TSCORES", "OW", "W", "GEN_BIN_PROFILES", "GWAMAR_DATASETS", "DATASET_DIR",  "MT", "EP"]
    passed_params = createCommandParams(params, parameters)

    print(passed_params)
    t0_time = time.time()
    if os.system(python_cmd + " sc1_compute_std_scores.py" + passed_params): exit()
    if os.system(python_cmd + " sc2_save_std_rankings.py" + passed_params): exit()
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "standard scores")

def scores_ranks(parameters):
    os.chdir(os.path.abspath("src/drsoft/scoring/"))

    params = ["D", "REVORDER", "SCORES", "NSCORES", "TSCORES", "OW", "W", "GEN_BIN_PROFILES", "GWAMAR_DATASETS", "DATASET_DIR",  "MT", "EP"]
    passed_params = createCommandParams(params, parameters)

    print(passed_params)
    t0_time = time.time()
    if os.system(python_cmd + " sc2_save_std_rankings.py" + passed_params): exit()
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "standard scores")
    
def scores_pvalues(parameters):
    os.chdir(os.path.abspath("src/drsoft/scoring/"))

    params = ["D", "REVORDER", "SCORES", "NSCORES", "TSCORES", "OW", "W", "GEN_BIN_PROFILES", "GWAMAR_DATASETS", "DATASET_DIR",  "MT", "EP"]
    passed_params = createCommandParams(params, parameters)

    t0_time = time.time()
    if os.system(python_cmd + " sc3_compute_perm_scores.py" + passed_params): exit()
    if os.system(python_cmd + " sc4_save_perm_rankings.py" + passed_params): exit()
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "pvalues scores")
    
def scores_norm(parameters):
    os.chdir(os.path.abspath("src/drsoft/scoring/"))

    params = ["D", "REVORDER", "SCORES", "NSCORES", "TSCORES", "OW", "W", "GEN_BIN_PROFILES", "GWAMAR_DATASETS", "DATASET_DIR",  "MT", "EP"]
    passed_params = createCommandParams(params, parameters)

    t0_time = time.time()
    if os.system(python_cmd + " sc7_compute_norm_scores.py" + passed_params): exit()
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "normalized scores")
    

def perm_test(parameters):
    os.chdir(os.path.abspath("src/drsoft/permtest/"))

    params = ["D", "REVORDER", "SCORES", "NSCORES", "TSCORES", "OW", "W", "GEN_BIN_PROFILES", "GWAMAR_DATASETS", "DATASET_DIR",  "MT", "EP"]
    passed_params = createCommandParams(parameters, parameters)

    t0_time = time.time()
    if os.system(python_cmd + " perm1_generate_res_profiles.py" + passed_params): exit()
    if os.system(python_cmd + " perm2_compute_perm_rep_scores.py" + passed_params): exit()
    if os.system(python_cmd + " perm3_save_perm_rep_rankings.py" + passed_params): exit()
    if os.system(python_cmd + " perm4_compute_perm_comb_scores.py" + passed_params): exit()
    if os.system(python_cmd + " perm5_combine_perm_rep_scores.py" + passed_params): exit()
    if os.system(python_cmd + " perm6_calc_pvalues.py" + passed_params): exit()
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "permutation test")
    
def analysis_sum(parameters):
    os.chdir(os.path.abspath("src/drsoft/analysis/"))

    params = ["D", "REVORDER", "SCORES", "CSCORES", "OW", "W", "GEN_BIN_PROFILES", "GWAMAR_DATASETS", "DATASET_DIR",  "MT", "EP"]
    passed_params = createCommandParams(parameters, parameters)

    t0_time = time.time()
    if os.system(python_cmd + " a1_save_details_scores_all.py" + passed_params): exit()
    if os.system(python_cmd + " a2_save_details_scores_sel.py" + passed_params): exit()
    if os.system(python_cmd + " a3_save_associations.py" + passed_params): exit()
    
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "analysis")

def comparison(parameters):
    os.chdir(os.path.abspath("src/drsoft/comparison/"))

    params = ["D", "REVORDER", "SCORES", "CSCORES", "OW", "W", "GEN_BIN_PROFILES", 
    "GWAMAR_DATASETS", "DATASET_DIR",   "EP", "RAND", "SUBSETS"]
    passed_params = createCommandParams(parameters, parameters)

    t0_time = time.time()

    if os.system(python_cmd + " cmp1_save_stats_lists_rep.py" + passed_params): exit()
    if os.system(python_cmd + " cmp2_comp_stats_rep.py" + passed_params): exit()
    if os.system(python_cmd + " cmp3_draw_figures.py" + passed_params): exit()
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "comparison")

def paper(parameters):
    os.chdir(os.path.abspath("src/drsoft/paper/"))

    params = ["D", "REVORDER", "SCORES", "CSCORES", "OW", "W", "GEN_BIN_PROFILES", 
    "GWAMAR_DATASETS", "DATASET_DIR",   "EP", "RAND", "SUBSETS"]
    passed_params = createCommandParams(parameters, parameters)

    t0_time = time.time()
    if os.system(python_cmd + " tb3_save_scored_lists_sel.py" + passed_params): exit()
    if os.system(python_cmd + " tb4_save_scored_lists_latex.py" + passed_params): exit()
    if os.system(python_cmd + " tb5_save_scored_lists_latex.py" + passed_params): exit()
    
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "analysis")


def analysis_stat(parameters):
    os.chdir(os.path.abspath("src/drsoft/comparison/"))

    params = ["D", "REVORDER", "SCORES", "CSCORES", "OW", "W", "GEN_BIN_PROFILES", 
    "GWAMAR_DATASETS", "DATASET_DIR",   "EP", "RAND", "SUBSETS"]
    passed_params = createCommandParams(parameters, parameters)

    t0_time = time.time()
    if os.system(python_cmd + " cmp2_comp_stats_rep.py" + passed_params): exit()
    if os.system(python_cmd + " cmp3_draw_figures.py" + passed_params): exit()
#    if os.system(python_cmd + " tb6_draw_figures.py" + passed_params): exit()
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "analysis")

def analysis_fig(parameters):
    os.chdir(os.path.abspath("src/drsoft/comparison/"))

    params = ["D", "REVORDER", "SCORES", "CSCORES", "OW", "W", "GEN_BIN_PROFILES", 
    "GWAMAR_DATASETS", "DATASET_DIR",   "EP", "RAND", "SUBSETS"]
    passed_params = createCommandParams(parameters, parameters)

    t0_time = time.time()
    if os.system(python_cmd + " cmp3_draw_figures.py" + passed_params): exit()
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "analysis")

def comp_mutations(parameters):
    os.chdir(os.path.abspath("src/drsoft/compensatory/"))

    params = ["D", "REVORDER", "SCORES", "CSCORES", "OW", "W", 
    "GWAMAR_DATASETS", "DATASET_DIR"]
    passed_params = createCommandParams(parameters, parameters)

    t0_time = time.time()
    if os.system(python_cmd + " show0_save_putative_muts.py" + passed_params): exit()
    if os.system(python_cmd + " show1_latex_rpoB_figure.py" + passed_params): exit()
    if os.system(python_cmd + " show2_latex_rpoB_table.py" + passed_params): exit()
    if os.system(python_cmd + " show3_show_comp_rels.py" + passed_params): exit()
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "analysis")


def preparebroad(parameters):
    os.chdir(os.path.abspath("src/prebroad/prepare/"))

    params = ["D", "REVORDER", "SCORES", "CSCORES", "OW", "W", 
    "GWAMAR_DATASETS", "DATASET_DIR"]
    passed_params = createCommandParams(parameters, parameters)

    t0_time = time.time()
    if os.system(python_cmd + " p1_download_files.py" + passed_params): exit()
    if os.system(python_cmd + " p2_save_strains.py" + passed_params): exit()
    if os.system(python_cmd + " p3_save_resdata.py" + passed_params): exit()
    if os.system(python_cmd + " p4_combine_resistance_profiles.py" + passed_params): exit()
    if os.system(python_cmd + " p5_save_point_mutations_aa.py" + passed_params): exit()
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "analysis")

def preparebroadtree(parameters):
    os.chdir(os.path.abspath("src/prebroad/tree/"))

    params = ["D", "REVORDER", "SCORES", "CSCORES", "OW", "W", 
    "GWAMAR_DATASETS", "DATASET_DIR"]
    passed_params = createCommandParams(parameters, parameters)

    t0_time = time.time()
    if os.system(python_cmd + " t0_save_point_mutations_nt.py" + passed_params): exit()
    if os.system(python_cmd + " t1_prepare_alignments.py" + passed_params): exit()
    if os.system(python_cmd + " t2_compute_subset_tree.py" + passed_params): exit()
    if os.system(python_cmd + " t3_resolve_clusters.py" + passed_params): exit()
    if os.system(python_cmd + " t4_save_strains_ordered.py" + passed_params): exit()
    t1_time = time.time()
    os.chdir("../../../")
    logExecutionTime(t1_time - t0_time, "analysis")

if __name__ == '__main__':
    #print(os.curdir, os.path.abspath(os.curdir), camber_path, run_path)
    os.chdir(run_path)
    #print(os.curdir, os.path.abspath(os.curdir), camber_path, run_path)
    parameters = overwriteParameters(sys.argv)
    parameters = readParameters()
    
    WORKERS = int(parameters["W"])
            
    python_cmd = sys.executable 
    action = parameters["A"].upper()
    
    if action == "P":
        prepare(parameters)
    elif action == "S":
        scores_std(parameters)
    elif action == "SR":
        scores_ranks(parameters)
    elif action == "SN":
        scores_norm(parameters)
    elif action == "SP":
        scores_pvalues(parameters)
    elif action == "PV":
        perm_test(parameters)
    elif action in ["A","AS"]:
        analysis_sum(parameters)
    elif action in ["C","CMP"]:
        comparison(parameters)
    elif action == "CM":
        comp_mutations(parameters)
    elif action == "AR":
        analysis_stat(parameters)
    elif action == "AF":
        analysis_fig(parameters)
    elif action == "PB":
        preparebroad(parameters)
        preparebroadtree(parameters)
    elif action == "PBT":
        preparebroadtree(parameters)
    else:
        print("Unknown action: " + action);
