import sys
import os
import time
import math
import shutil
import random
import multiprocessing
from multiprocessing import Pool

sys.path.append("../../")

from drsoft.utils.gwamar_params_utils import *
from drsoft.utils.gwamar_utils import ensure_dir


if __name__ == '__main__':

    
    parameters = overwriteParameters(sys.argv)
    parameters = readParameters()
    
    cmp_dir = parameters["RESULTS_CMP_DIR"]
    dataset = parameters["D"]

    assocs_dir = cmp_dir + "/assocs/"
    ensure_dir(assocs_dir)
    ensure_dir(cmp_dir)

    scores_list = []
    for score_fn in os.listdir(assocs_dir):
        score = score_fn[:-4]
        scores_list.append(score)

    subsets = parameters.get("SUBSETS", "eq1,eq3").split(",")

    for subset in subsets:
        assocs_dir = cmp_dir + "/assocs/"
        stats_dir = cmp_dir + "/stats_"+subset+"/"
        script_dir = parameters["GWAMAR_SRC"] + "visR/curves/"
        command = "Rscript "+script_dir + "/pr_scores_rand.R " + dataset + " " + parameters["MT"] + " " + subset + " " + parameters["GWAMAR_PATH"]
        print(command)
        sys.stdout.flush()
        os.system(command)
        script_dir = parameters["GWAMAR_SRC"] + "visR/curves/"
        command = "Rscript "+script_dir + "/pr_bars.R " + dataset + " " + parameters["MT"] + " " + subset + " " + parameters["GWAMAR_PATH"]
        print(command)
        os.system(command)
    
    print("cmp3_draw_figures.py: Finished.")
     
# script_dir = parameters["GWAMAR_SRC"] + "visR/curves/"
        # command = "Rscript "+script_dir + "/roc_scores_rand.R " + dataset + " " + parameters["MT"] + " " + subset + " " + parameters["GWAMAR_PATH"]
        # print(command)
        # os.system(command)
    #    except:
     #   print("Problem with running R")
    