import os
import sys
import time
from StringIO import StringIO
from multiprocessing import Pool
import multiprocessing

sys.path.append("../../")

from drsoft.utils.gwamar_params_utils import *
from drsoft.utils.gwamar_utils import *
from drsoft.utils.gwamar_strains_io_utils import *

def getTreeStrainList(tree_line):
    tree_line = tree_line.strip().strip(";")
    tree_line = tree_line.replace("(", ";")
    tree_line = tree_line.replace(")", ";")
    tree_line = tree_line.replace(",", ";")
    strains_list_tmp = tree_line.split(";")
    strains_list = []
    for strain_id_tmp in strains_list_tmp:
        if strain_id_tmp.count(":") > 0: strain_id = strain_id_tmp.split(":")[0]
        else: strain_id = strain_id_tmp
        if len(strain_id) == 0: continue
        strains_list.append(strain_id)
    return strains_list


if __name__ == '__main__':
    print("p0_save_strains_ordered.py: saves strains in the order consistent with the phylogenetic tree.")
    parameters = overwriteParameters(sys.argv)
    parameters = readParameters()
    
    input_dir = parameters["DATASET_INPUT_DIR"]

    input1_fn = input_dir + "/tree.txt"
    input2_fn = input_dir + "/strains_ordered.txt"
    input3_fn = input_dir + "/strains.txt"

    if os.path.exists(input1_fn) and not os.path.exists(input2_fn) and os.path.exists(input3_fn):
        input_fh = open(input1_fn)
        tree_line = input_fh.readline()
        input_fh.close()
        strains_list = getTreeStrainList(tree_line)

        output_fh = open(input2_fn, "w")
        for strain_id in strains_list:
            output_fh.write(strain_id + "\n")
        output_fh.close()
    elif not os.path.exists(input1_fn) and os.path.exists(input3_fn): 
        input_fh = open(input3_fn)
        strains = readStrains(input_fh)
        input_fh.close()
        strains_list = strains.allStrains()

        output_fh = open(input2_fn, "w")
        for strain_id in strains_list:
            output_fh.write(strain_id + "\n")
        output_fh.close()
    else:
        print("File " + input2_fn + " already exists. First remove it.")
    
    print("p0_save_strains_ordered.py. Finished.")
