#include <stdio.h>
import copy

def printc(comb, k):
    text = ""
    for i in range(0, k, 1):
        text += str(comb[i] + 1);
    print(text);


def next_comb(comb, k, n):
    i = k - 1;
    comb[i] += 1;
    while(i > 0 and comb[i] >= n):
        comb[i] = 0;
        i-=1;
        comb[i] += 1;

    if (comb[0] == n):
        return 0; 

    return 1;

def next_comb_map(comb, m_map):
    k = len(m_map)
    i = k - 1;
    n = m_map[i]
    comb[i] += 1;
    while(i > 0 and comb[i] >= n):
        comb[i] = 0;
        i-=1;
        n = m_map[i]
        comb[i] += 1;
    if (comb[0] == m_map[0]):
        return 0; 
    return 1;

def copyRes(k, comb):
    comb_res = {}
    for i in range(0, k, 1):
        if(comb[i] == 0):
            comb_res[i] = "S"
        else:
            comb_res[i] = "R"
    return comb_res

def copyMut(k, comb):
    comb_res = {}
    for i in range(0, k, 1):
        if(comb[i] == 0):
            comb_res[i] = "0"
        else:
            comb_res[i] = "1"
    return comb_res

def copyResMut(k, comb):
    comb_res = {}
    for i in range(0, k, 1):
        if(comb[i] == 0):
            comb_res[i] = ("0","S")
        elif (comb[i] == 1):
            comb_res[i] = ("0","R")
        elif(comb[i] == 2):
            comb_res[i] = ("1","S")
        elif (comb[i] == 3):
            comb_res[i] = ("1","R")
                        
    return comb_res

def generateResistanceProfiles(k):
    n = 2;
    if k==0:
        return {};
    combs = {};
    comb = [0]*k; 
    
    num = 0;
    for i in range(0,k,1):
        comb[i] = 0;
    combs[num] = copyRes(k, comb)
    num += 1;
    while (next_comb(comb, k, n)):
        combs[num]=copyRes(k, comb)
        num += 1
    return combs

def generateBinMutationProfiles(k):
    n = 2;
    if k==0:
        return {};
    combs = {};
    comb = [0]*k; 
    
    num = 0;
    for i in range(0,k,1):
        comb[i] = 0;
    combs[num] = copyMut(k, comb)
    num += 1;
    while (next_comb(comb, k, n)):
        combs[num]=copyMut(k, comb)
        num += 1
    return combs

def f(n, s, m, ub=None):
    if n == 0:
        pass
    elif n == 1:
        if ub == None:
            if s <= m:
                yield (s,)
        else:
            if s <= m and s<=ub[0]:
                yield (s,)
    else:
        if ub == None:
            for i in xrange(min(s + 1, m + 1)):
                for j in f(n - 1,s - i, m):     
                    yield (i,) + j
        else:
            for i in xrange(min(s, m, ub[0]) + 1):
                for j in f(n - 1, s - i, m, ub[1:]):     
                    yield (i,) + j

def g(n, s, lb=None, ub=None):
    if n == 0:
        pass
    elif n == 1:
        if lb == None and ub == None: yield (s,)
        elif lb == None:
            if s <= ub[0]: yield (s,)
        elif ub == None:
            if s >= lb[0]: yield (s,)
        else:
            if s >= lb[0] and s<=ub[0]: yield (s,)
    else:
        if lb == None and ub == None:
            for i in xrange(s+1):
                for j in g(n-1, s-i):     
                    yield (i,) + j
        elif lb == None:
            for i in xrange(min(s, ub[0]) + 1):
                for j in g(n-1, s-i, ub=ub[1:]):     
                    yield (i,) + j
        elif ub == None:
            for i in xrange(lb[0], s+1, 1):
                for j in g(n-1, s-i, lb=lb[1:]):     
                    yield (i,) + j
        else:
            for i in xrange(lb[0], min(s,ub[0])+1, 1):
                for j in g(n-1, s-i, lb[1:], ub[1:]):     
                    yield (i,) + j


def generateSumProfiles(k, s, m, ub=None):
    try:
        return list(f(k, s, m, ub))
    except:
        print("error", k, s, m, ub, ub[::-1])
        return []

def generateSumProfiles2(k, s, lb=None, ub=None):
    try:
        return list(g(k, s, lb, ub))
    except:
        print("error", k, s, lb, ub, ub[::-1])
        return []

def generateResBinMutationProfiles(k):
    n = 4;
    if k==0:
        return {};
    combs = {};
    comb = [0]*k; 
    
    num = 0;
    for i in range(0,k,1):
        comb[i] = 0;
    combs[num] = copyResMut(k, comb)
    num += 1;
    while (next_comb(comb, k, n)):
        combs[num]=copyResMut(k, comb)
        num += 1
    return combs


def choose_iter(elements, length):
    for i in range(len(elements)):
        if length == 1:
            yield (elements[i],)
        else:
            for next in choose_iter(elements[i+1:len(elements)], length-1):
                yield (elements[i],) + next
                
def choose(l, k):
    return list(choose_iter(l, k))
        
def main():
    n = 2;
    k = 5; 
    comb = [0]*k; 

    printc(comb, k);

    while (next_comb(comb, k, n)):
        printc(comb, k);

    return 0;

def allCombinationsN(map, n_max):
    curr_combs = [({},0)]
    final_combs = []
    new_combs = []
    n = len(map)
    if n == 0:
        return []
    for w in map:
        w_n = map[w]
        for comb in curr_combs:
            for i in range(0, w_n+1, 1):
                (new_comb, n_w) = copy.deepcopy(comb)
                if n_w + i > n_max:
                    continue
                new_comb[w] = i
                new_combs.append((new_comb, n_w+i))
        curr_combs = new_combs
        new_combs = []
    for (comb, n_w) in curr_combs:
        final_combs.append(comb)
    return final_combs

    
def allCombinations(maps):
    curr_combs = []
    new_combs = []
    n = len(maps)
    if n == 0:
        return []
    for key in maps[0]:
        curr_combs.append([key])
    if n == 1:
        return curr_combs
    for k in range(1, n, 1):
        for key in maps[k]:
            for comb in curr_combs:
                new_comb = copy.deepcopy(comb)
                new_comb.append(key)
                new_combs.append(new_comb)
        curr_combs = new_combs
        new_combs = []
    return curr_combs

#print(generateSumProfiles2(4, 10, lb=[1,2,1,0]))
#print(generateResistanceProfiles([1,2,3]))
#maps = [{1:1,2:1},{4:2,6:1},{4:2,2:1}]
##maps = []
#combs = allCombinations(maps)
#print(maps)
#print(combs)
#    
#
#m_map = {0: 4, 1:2, 2:1}
#comb = [0]*len(m_map); 
#
#while next_comb_map(comb, m_map):
#    print(comb)
#    
    