import sys
import os
import platform


sys.path.append("../../")

parameters_map = {}

key_map = {"ACTION":"A", "a": "A",
           "WORKERS": "W", "W": "W", "w": "W",
           "DATASET": "D", "d": "D",
           "s":"SCORES", "S":"SCORES", "scores":"SCORES",
           "cs":"CSCORES", "CS": "CSCORES", "cscores": "CSCORES",
           "EXP_PREFIX": "EP", "e": "EP",
           "PERM_REP": "PR", "pr": "PR",
           "reps": "REPS",
           "MT": "MT", "mt": "MT",
           "OVERWRITE": "OW", "overwrite": "OW",
           "EXP_DIR":"ED", "ed": "ED",
           "SHOW_PROFILES": "SP", "sp":"SP",
           }

def shortKey(key_tmp):
    key = key_map.get(key_tmp, key_tmp)
    return key

def readParametersFromFile(input_fn, parameters_map):
    input_fh = open(input_fn);

    for line in input_fh.readlines():
        line = line.strip().split("#")[0].strip()
        tokens = line.split(":")
        if len(tokens) < 2:
            continue
        key_tmp = tokens[0]
        key = shortKey(key_tmp)
        if key == "GWAMAR_PATH":
            pass;#parameters_map[key] = os.path.abspath(tokens[1])+"/"
        else:
            value = ""
            for i in range(1, len(tokens), 1):
                if tokens[i] in parameters_map:
                    value += parameters_map[tokens[i]]
                else:
                    value += tokens[i]
            if not key in parameters_map:
                parameters_map[key] = value

    input_fh.close()
    return parameters_map;

def getGWAMARPath():
    curr_path = os.path.abspath(sys.argv[0])
    curr_path = os.path.abspath(os.path.join(curr_path, ".."))
    tmp_path = curr_path
    gwamar_path = curr_path
    last_tmp_path = tmp_path
    it_count = 0
    while len(tmp_path) > 1 and it_count < 20:
        it_count += 1
        curr_dir = os.path.basename(tmp_path)
        curr_path = os.path.abspath(os.path.join(tmp_path, ".."))
        sys.stdout.flush()
        
        if curr_dir.startswith("gwamar"):
            gwadrib_path = tmp_path + "/"
            break
        elif os.path.exists(curr_path + "/gwamar/"):
            gwadrib_path = curr_path + "/gwamar/"
            break
        else:
            tmp_path = curr_path
        if last_tmp_path == tmp_path or it_count == 20:
            print("Cannot determine GWAMAR path")
            exit()
    return gwadrib_path;


def overwriteParameters(sys_argv):
    global parameters_map;
    
    gwadrib_path = getGWAMARPath()
    os.chdir(gwadrib_path)
    
    parameters_map["GWAMAR_PATH"] = gwadrib_path

    args_list = list(sys_argv)
    
    n = len(args_list)
    i = 0
    while i < n:
        arg = args_list[i]
        if arg.startswith("-"):
            if arg.count("=") == 1:
                tokens = arg.split("=")
                key_tmp = tokens[0][1:]
                value = tokens[1]
                i += 1
            else:
                key_tmp = arg[1:]
                if i < n-1: value = args_list[i+1]
                else: value = ""
                i += 2
        elif arg.count("=") == 1:
            tokens = arg.split("=")
            key_tmp = tokens[0]
            value = tokens[1]
            i += 1
        else:
            # print("Argument ignored: " + arg)
            value = ""
            i += 1
            continue
        
        key = shortKey(key_tmp)
        parameters_map[key] = value
        
    return parameters_map


def readParameters():
    global parameters_map;
    config_dir = parameters_map["GWAMAR_PATH"] + "/config/"; 
    
    parameters_map = readParametersFromFile(config_dir+"config_params.txt", parameters_map)
    return parameters_map

