import os
import sys
import time
from StringIO import StringIO
from multiprocessing import Pool
import multiprocessing
try:
    from urllib.request import urlopen
except ImportError:
    from urllib2 import urlopen

sys.path.append("../../")

from drsoft.utils.gwamar_params_utils import *
from drsoft.utils.gwamar_utils import *
from drsoft.utils.gwamar_strains_io_utils import *


if __name__ == '__main__':
	print("Downloading files...")
	parameters = overwriteParameters(sys.argv)
	parameters = readParameters()
    
	input_dir = parameters["PREBROAD_DIR"]
	input_download_dir = parameters["PREBROAD_DOWNLOAD_DIR"]
	ensure_dir(input_dir)
	ensure_dir(input_download_dir)

	www = "http://www.broadinstitute.org/annotation/genome/mtb_drug_resistance.1/assets/GTBDR_120516.snps.zip"
	output_fn = input_download_dir + "GTBDR_120516.snps.zip"
	if not os.path.exists(output_fn):
		f = open(output_fn,'wb')
		f.write(urlopen(www).read())
		f.close()
		print("File with mutations.")
	else:
		print("File with mutations is already downloaded.")

	www = "http://www.broadinstitute.org/annotation/genome/mtb_drug_resistance.1/assets/GTBDR_120516.drugresistance.csv"
	output_fn = input_download_dir + "GTBDR_120516.drugresistance.csv"
	if not os.path.exists(output_fn):
		
		f = open(output_fn,'wb')
		f.write(urlopen(www).read())
		f.close()
		print("File with resistance information.")
	else:
		print("File with resistance information is already downloaded.")
	print("Files downloaded.")
