import sys
import os
import copy
import time
from collections import deque
from StringIO import StringIO
from multiprocessing import Pool
import multiprocessing

sys.path.append("../../")

from drsoft.utils.gwamar_params_utils import *
from drsoft.utils.gwamar_utils import *
from drsoft.utils.gwamar_muts_io_utils import *
from drsoft.utils.gwamar_tree_io_utils import *
from drsoft.utils.gwamar_strains_io_utils import *
from drsoft.structs.resistance_profile import ResistanceProfile

thr = 0.000000001

def transformTree(tree, clusters_map):
    for leaf_node in tree.root.getLeaves():
        strains_tmp = list(clusters_map[leaf_node.label].split(","))
        if len(strains_tmp) == 1:
            leaf_node.label = strains_tmp[0]
            leaf_node.node_id = strains_tmp[0]
      #      print("xxx", leaf_node.label, leaf_node.node_id)
        else:
            for strain_id in strains_tmp:
                new_leaf = ResTreeNode(strain_id, leaf_node, strain_id)
                new_leaf.e_len = 0.00001
                leaf_node.addChildren(new_leaf)
       #     print(leaf_node.label, len(strains_tmp), strains_tmp)
     #   print(leaf_node.node_id, leaf_node.parent.node_id, leaf_node.label)
   # for leaf_node in tree.root.getLeaves():
   #     print("yyy", leaf_node.label)
    return tree

if __name__ == '__main__':
    parameters = overwriteParameters(sys.argv)
    parameters = readParameters()
    
    m_type = parameters["PREBROAD_SUB"]
    phylo_dir = parameters["PREBROAD_TREE_DIR"]
    input_dir = parameters["PREBROAD_OUTPUT_DIR"]
    
    input_fh = open(phylo_dir + "/clusters_map_"+m_type+".txt")
    cluster_strains = readStrains(input_fh)
    input_fh.close()
    
    clusters_map = {}
    input_fh = open(phylo_dir + "/clusters_map_"+m_type+".txt")
    for line in input_fh.readlines():
        tokens = line.strip().split("\t")
        clusters_map[tokens[0]] = tokens[1].replace(" ", ",")
    input_fh.close()
    
#    print(cluster_strains.count(), cluster_strains.allStrains())
    
    input_fn = phylo_dir + 'phylotree_'+m_type+'.txt'
    output_fn = input_dir + 'tree.txt'
    input_fh = open(input_fn)
    output_fh = open(output_fn, "w")
    trees = readPhyloTrees(input_fh, cluster_strains.allStrains())
    tree = trees[0]
    tree_org = transformTree(tree, clusters_map)
    #print(tree.toString(lengths=True, strains=cluster_strains, int_labels=False))
    flat_tree = tree_org.flatten(thr)
#    print(tree_org.toString(lengths=True, strains=None, int_labels=False))
    text_line = flat_tree.toString(lengths=True, strains=None, int_labels=False) + ";\n"
    output_fh.write(text_line);
    output_fh.close();
    input_fh.close()

    print("t3_resolve_clusters.py. Finished.")
    