#install.packages(
require(graphics); require(grDevices);

#data_fn = paste(species_id, "_out/r_subset/", drug_name, ".txt", sep = "")

args <- commandArgs(trailingOnly = TRUE)

if (length(args) >=1) {
	dataset = args[1]
} else {
	#dataset="sau461"
	#dataset = "mtu173"
	dataset = "mtu_broad"
}

if (length(args) >= 2) {
	mut_type = args[2]
} else {
	mut_type = "P"
}

if (length(args) >= 3) {
	subset = args[3]
} else {
	subset = "sel3"
}

if (length(args) >= 4) {
	prefix = args[4]
} else {
	if (Sys.info()["sysname"] == "Linux") {
		prefix = "/home/misias/Dropbox/gwamar/"
	} else {
		prefix = "D:/Dropbox/Dropbox/gwamar/"
	}
}

input_fn = paste(prefix,"datasets/",dataset,"/ex",mut_type,"/comparison/", subset, ".txt", sep="")
print(input_fn)
#score_files = list.files(path = inputdir)
#print(score_files)


outdir = paste(prefix,"datasets/",dataset,"/ex",mut_type,"/figures/", sep="")
dir.create(outdir, showWarnings = FALSE)

#input_fn = paste(inputdir, "/",score_files[1], sep="")
data = read.table(input_fn, header=TRUE, sep="\t")

if (dataset == "mtu_broad") {
	if (subset == "sel3") {
		positives = 75
		negatives = 870
	} else {
		positives = 220
		negatives = 725
	}
} else if (dataset == "mtu173") {
	if (subset == "sel3") {
		positives = 39
		negatives = 1450
	} else {
		positives = 113
		negatives = 1376	
	}
} else if (ncol(data) > 4) {
	positives = data[1,1] + data[1,4]
	negatives = data[1,2] + data[1,3]
} else {
	positives = 0
	negatives = 0
}

scores_sel = c("mi", "or", "lh", "r.tgh", "ws", "ts")

cnames = colnames(data)

output_fn = paste(outdir, "/pr_bars_",dataset, "_", subset, ".pdf", sep="")
pdf(output_fn, width=18,height=10)
boxplot(data[, intersect(scores_sel, cnames)], par=2)
#boxplot(data[,], par=2)
dev.off()
